%define POLICYCOREUTILSVER 2.0.78-1
%define SELINUXTARGETEDVER 3.7.19-279
%define MANAGER_UID 61
%define PRELUDE_GROUP prelude

Name:  prelude-manager
Epoch:  1
Version: 3.1.0
Release: 1%{?dist}
Summary: Prelude-Manager

Group:  Applications/Internet
License: GPLv2+
URL:  https://www.prelude-siem.org
Source0: https://www.prelude-siem.org/pkg/prelude/src/%{name}-%{version}.tar.gz
Source1: %{name}.init
#Patch1:  %{name}-1.0.1-pie.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  libxml2-devel, libmaxminddb-devel
BuildRequires:  libpreludedb-devel >= 1:3.1.0
BuildRequires:  libpreludedb-devel < 1:3.2.0
BuildRequires:  libprelude-devel >= 1:3.1.0
BuildRequires:  libprelude-devel < 1:3.2.0
%if 0%{?fedora} > 6
BuildRequires:  tcp_wrappers-devel
%else
BuildRequires:  tcp_wrappers
%endif
Requires(pre)   : /usr/sbin/useradd
Requires(post) : /sbin/chkconfig
Requires(preun) : /sbin/chkconfig
Requires(preun) : /sbin/service
Requires(postun): /sbin/service
Requires: libprelude >= 1:3.1.0
Requires: libprelude < 1:3.2.0
Requires: libmaxminddb

%description
Prelude-Manager is a high availability server that
accepts secured connections from distributed sensors
and saves received events to a media specified by the user
(database, log file, mail etc.). The server schedules and
establishes the priorities of treatment according to the
critical character and the source of the alerts.

%package devel
Summary: Header files and libraries for prelude-manager development
Group: Development/Libraries
Requires: prelude-manager = %{epoch}:%{version}-%{release}, libpreludedb-devel

%description devel
Libraries, include files for Prelude-Manager.

%package        db-plugin
Summary: Database report plugin for Prelude IDS Manager
Group:  System Environment/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires:  libpreludedb >= 1:3.1.0
Requires:  libpreludedb < 1:3.2.0

%description    db-plugin
This plugin allows prelude-manager to write to database.

%package xml-plugin
Summary: XML report plugin for Prelude IDS Manager
Group:  System Environment/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}

%description    xml-plugin
This plugin adds XML logging capabilities to prelude-manager.

%package smtp-plugin
Summary: SMTP alert plugin for Prelude IDS Manager
Group:  System Environment/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}

%description    smtp-plugin
This plugin adds alerting by email capabilities to prelude-manager

%package selinux
Summary: SELinux policy for prelude-manager
Provides: selinux-policy-base
Group: System Environment/Base
BuildRequires: checkpolicy
BuildRequires: policycoreutils >= %{POLICYCOREUTILSVER}
BuildRequires: bzip2
Requires(pre): policycoreutils >= %{POLICYCOREUTILSVER}
Requires(pre): coreutils
Requires(pre): selinux-policy-targeted >= %{SELINUXTARGETEDVER}
Requires: selinux-policy-targeted >= %{SELINUXTARGETEDVER}
Requires: prelude-manager = %{epoch}:%{version}-%{release}
Requires(post): policycoreutils >= %{POLICYCOREUTILSVER}
Requires(postun): policycoreutils >= %{POLICYCOREUTILSVER}
BuildArch: noarch

%description selinux
SELinux policy for prelude-manager

%define loadpolicy() \
. %{_sysconfdir}/selinux/config; \
( cd /usr/share/selinux/%1; semodule -n -b base.pp.bz2 -i %{name}.pp.bz2 -s %1 &> /dev/null ); \

%prep
%setup -q
#%patch1 -p1

%build
export CFLAGS="$RPM_OPT_FLAGS"
%configure --enable-libmaxminddb \
           --with-libwrap=yes
make %{?_smp_mflags}
cd $RPM_BUILD_DIR/%{name}-%{version}/selinux/
make

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_defaultdocdir}/%{name}-%{version}
mkdir -p %{buildroot}/%{_initrddir}
mkdir -p %{buildroot}/%{_var}/spool/prelude-manager/scheduler
mkdir -p %{buildroot}/%{_datadir}/selinux/targeted/
make install DESTDIR=%{buildroot} INSTALL="%{__install} -c -p"
install -m 755 %{SOURCE1} %{buildroot}/%{_initrddir}/%{name}
install -m 644 $RPM_BUILD_DIR/%{name}-%{version}/selinux/%{name}.pp.bz2 \
    %{buildroot}/%{_datadir}/selinux/targeted/
rm -f %{buildroot}/%{_libdir}/%{name}/reports/*.la
rm -f %{buildroot}/%{_libdir}/%{name}/filters/*.la
rm -f %{buildroot}/%{_libdir}/%{name}/decodes/*.la
rm -f %{buildroot}%{_defaultdocdir}/%{name}/smtp/template.example

%clean
rm -rf %{buildroot}

%pre
getent passwd prelude-manager >/dev/null || \
/usr/sbin/useradd -M -r -d / -s /sbin/nologin \
                  -c "prelude-manager" -u %{MANAGER_UID} \
                  prelude-manager > /dev/null 2>&1 || :
/usr/sbin/usermod -g %{PRELUDE_GROUP} prelude-manager > /dev/null 2>&1 || :

%post
/sbin/ldconfig
/sbin/chkconfig --add %{name}

%post selinux
if [ $1 -eq 1 ]; then
   %loadpolicy targeted prelude-manager
   restorecon -R /dev/shm/ || :
else
   semodule -n -s targeted -r prelude-manager 2>/dev/null
   %loadpolicy targeted prelude-manager
fi

%preun
if [ $1 = 0 ]; then
 /sbin/service %{name} stop > /dev/null 2>&1 || :
 /sbin/chkconfig --del %{name}
fi

%postun 
/sbin/ldconfig
if [ "$1" -ge "1" ]; then
 /sbin/service %{name} condrestart >/dev/null 2>&1 || :
fi

%postun selinux
semodule -n -s targeted -r prelude-manager 2>/dev/null || :
/sbin/restorecon -R /dev/shm/ || :

%files
%defattr(-,root,root,-)
%doc COPYING
%attr(0750,prelude-manager,prelude) %dir %{_sysconfdir}/%{name}/
%config(noreplace) %attr(0640,prelude-manager,prelude) %{_sysconfdir}/%{name}/*
%{_initrddir}/%{name}
%dir %{_bindir}/%{name}
%dir %{_libdir}/%{name}/
%dir %{_libdir}/%{name}/filters/
%{_libdir}/%{name}/filters/*.so
%dir %{_libdir}/%{name}/reports/
%{_libdir}/%{name}/reports/debug.so
%{_libdir}/%{name}/reports/textmod.so
%dir %{_libdir}/%{name}/decodes/
%{_libdir}/%{name}/decodes/*.so
%attr(0750,prelude-manager,prelude) %dir %{_localstatedir}/spool/%{name}/
%attr(0750,prelude-manager,prelude) %dir %{_localstatedir}/spool/%{name}/scheduler
%attr(0750,prelude-manager,prelude) %dir %{_localstatedir}/run/%{name}/
%attr(0750,prelude-manager,prelude) %dir %{_datadir}/%{name}/
%attr(0644,root,root) %{_mandir}/man1/prelude-manager.1.gz

%files db-plugin
%defattr(-,root,root,-)
%{_libdir}/%{name}/reports/db.so

%files xml-plugin
%defattr(-,root,root,-)
%{_libdir}/%{name}/reports/xmlmod.so
%attr(0750,root,root) %dir %{_datadir}/%{name}/xmlmod/
%{_datadir}/%{name}/xmlmod/*

%files smtp-plugin
%defattr(-,root,root,-)
%doc %attr(0644,root,root) plugins/reports/smtp/template.example
%{_libdir}/%{name}/reports/smtp.so

%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/%{name}/
%{_includedir}/%{name}/*

%files selinux
%{_datadir}/selinux/targeted/%{name}.pp.bz2

%changelog
* Wed Sep 14 2016 Thomas Andrejak <thomas.andrejak@c-s.fr> - 3.1.0-1
- New upstream release

* Thu Sep 01 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.1.0rc3-1
- New upstream release

* Fri Aug 19 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.1.0rc2-1
- New upstream release

* Wed Aug 10 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.1.0rc1-2
- Add libmaxminddb dependency
- Fix libprelude dependencies

* Sun Aug 07 2016 Thomas Andrejak <thomas.andrejak@c-s.fr> - 3.1.0rc1-1
- New upstream release

* Thu Apr 21 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.0.0-1
- New upstream release

* Fri Apr 15 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.0.0rc4-1
- New upstream release

* Fri Apr 08 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc3-1
- New upstream release

* Fri Apr 01 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc2-1
- New upstream release

* Fri Mar 25 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc1-1
- New upstream release

* Fri Mar 18 2016 Song Tran <song.tran@c-s.fr> - 1.3.0beta2-1
- New upstream release
- Mask the messages of usermod command

* Fri Feb 26 2016 Song Tran <song.tran@c-s.fr> - 1.3.0beta1-1
- New upstream release
- Add libprelude dependency
- Use a dedicated prelude-manager user
- Integrate SELinux policy

* Tue Jan 12 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0alpha1-1
- New upstream release

* Wed Jul 22 2015 Antoine Luong <antoine.luong@c-s.fr> - 1.2.6-1
- New upstream release

* Thu Oct 16 2014 Antoine Luong <antoine.luong@c-s.fr> - 1.2.6rc3-1
- New upstream release

* Tue Sep 16 2014 Song Tran <song.tran@c-s.fr> - 1.2.6rc1-1
- New upstream release

* Wed Jun 15 2011 Vincent Quéméner <vincent.quemener@c-s.fr> 1.0.1-3
- Rebuilt for RHEL6

* Fri Mar 25 2011 Steve Grubb <sgrubb@redhat.com> 1.0.1-2
- Disable pie patch for now

* Thu Mar 24 2011 Steve Grubb <sgrubb@redhat.com> 1.0.1-1
- new upstream version

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun May 02 2010 Steve Grubb <sgrubb@redhat.com> 1.0.0-3
- Fix requires

* Fri Apr 30 2010 Steve Grubb <sgrubb@redhat.com> 1.0.0-2
- new upstream version

* Sat Jan 30 2010 Steve Grubb <sgrubb@redhat.com> 1.0.0rc1-1
- new upstream version

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.15-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Jul 10 2009 Steve Grubb <sgrubb@redhat.com> 0.9.15-1
- new upstream version

* Wed Apr 22 2009 Steve Grubb <sgrubb@redhat.com> 0.9.14.2-3
- Adjusted permissions on dirs and conf files

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.14.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Aug 27 2008 Steve Grubb <sgrubb@redhat.com> 0.9.14.2-1
- new upstream version

* Mon Jul 21 2008 Steve Grubb <sgrubb@redhat.com> 0.9.14-1
- new upstream version

* Fri Jun 27 2008 Steve Grubb <sgrubb@redhat.com> 0.9.13-1
- new upstream version 0.9.13
- Prelude-Manager-SMTP plugin is now included

* Tue Jun 24 2008 Steve Grubb <sgrubb@redhat.com> 0.9.12.1-2
- add prelude-manager user

* Fri May 02 2008 Steve Grubb <sgrubb@redhat.com> 0.9.12.1-1
- new upstream version 0.9.12.1

* Thu Apr 24 2008 Steve Grubb <sgrubb@redhat.com> 0.9.12-1
- new upstream version 0.9.12

* Mon Jan 14 2008 Steve Grubb <sgrubb@redhat.com> 0.9.10-1
- new upstream version 0.9.10

* Thu Feb 08 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.7.1-4
- fixed Prelude trac #193

* Sun Jan 07 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.7.1-3
- added tcp-wrapper support
- fixed dirowner and permissions problem

* Fri Jan 05 2007 Thorsten Scherf <tscherf@redhat.com> 0.9.7.1-2
- fixed encoding problems
- changed dirowner
- resolved dependency problems

* Sat Dec 30 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.7.1-1
- moved to new upstream version 0.9.7.1
- changed dirowner

* Mon Nov 20 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.6.1-2
- Some minor fixes in requirements

* Tue Oct 24 2006 Thorsten Scherf <tscherf@redhat.com> 0.9.6.1-1
- New Fedora build based on release 0.9.6.1
